import java.util.Date
import com.commentout.nihohi.Entry
import com.commentout.nihohi.PostWriteback
import org.prevayler.Prevayler

class Post {
	Integer id
	String  name
	String  body
	
	List   errors = []
	Locale locale = Locale.ENGLISH
	
	Entry entry

	private prevayler
	
	Post(Prevayler p){
		prevayler = p
	}
	writeback() {
		validate()
		entry = prevayler.system().findById(id)
		if(errors.size() > 0)
			return "entry"
		cmd = new PostWriteback(id: id, name: name, body: body, date: new Date())
		prevayler.executeCommand(cmd)
		
		return "store"
	}
	private validate(){
		if(id == null)
			errors << "System error; Missing id."
		if(name == null || name == "")
			errors << "Please input your name."
		if(body == null || body == "")
			errors << "Please input the body."
		if(name.size() > 40)
			errors << "The name is too long."
		if(body.size() > 2000)
			errors << "The body is too long."
	}
}